﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Table;

namespace WebRole1
{
    public partial class _Default : Page
    {

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                // Use the local storage emulator
                var storageAccount = CloudStorageAccount.DevelopmentStorageAccount;
                // Create a cloud table client object
                CloudTableClient tableClient = storageAccount.CreateCloudTableClient();
                // Create an email address table object
                CloudTable emailAddressTable = tableClient.GetTableReference("EmailAddressTable");
                // Create the table if it does not exist
                // Only insert a new record once for this demo
                if (emailAddressTable.CreateIfNotExists() == true)
                {
                    // Create a new EmailAddressEntity entity
                    EmailAddressEntity emailaddress = new
                        EmailAddressEntity("bterkaly@microsoft.com", "555-555-5555");
                    // Create an operation to add the new email and phone number to 
                    // the EmailAddress table.
                    TableOperation insertEmail = TableOperation.Insert(emailaddress);
                    // Submit the operation to the table service.
                    emailAddressTable.Execute(insertEmail);
                }
            }
            catch (Exception ex)
            {
                
                // Put the message in the web page title (for testing purposes)
                // Real error messages should go to a proper log file
                this.Title = ex.Message.ToString();
                throw;
            }


        }

        protected void Button1_Click(object sender, EventArgs e)
        {
            // Use the local storage emulator
            var storageAccount = CloudStorageAccount.DevelopmentStorageAccount;
            try
            {
                // Create the table client.
                CloudTableClient tableClient = storageAccount.CreateCloudTableClient();
                CloudTable emailAddressTable = tableClient.GetTableReference("EmailAddressTable");

                // Retrieve the entity with partition key of "microsoft.com" and row key of "bterkaly"
                TableOperation retrieveBrunoEmail = TableOperation.Retrieve<EmailAddressEntity>("microsoft.com", "bterkaly");

                // Retrieve entity
                EmailAddressEntity specificEntity = (EmailAddressEntity)emailAddressTable.Execute(retrieveBrunoEmail).Result;
                TableResult result = emailAddressTable.Execute(TableOperation.Retrieve<EmailAddressEntity>("microsoft.com", "bterkaly"));

                // Pull the data out that you searched for
                // Do something with emailAddress and phoneNumber
                string emailAddress = specificEntity.EMailAddress;
                string phoneNumber = specificEntity.PhoneNumber;

            }
            catch (Exception ex)
            {
                // Put the message in the web page title (for testing purposes)
                // Real error messages should go to a proper log file
                this.Title = ex.Message.ToString();
                throw;
            }


        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            // Use the local storage emulator
            var storageAccount = CloudStorageAccount.DevelopmentStorageAccount;
            // Create a cloud table client object
            CloudTableClient tableClient = storageAccount.CreateCloudTableClient();
            // Create an email address table object
            CloudTable emailAddressTable = tableClient.GetTableReference("EmailAddressTable");
            // Set up the filter for the partition key
            string pkFilter = TableQuery.GenerateFilterCondition("PartitionKey", QueryComparisons.Equal, "microsoft.com");
            // Set up the filter for the row key
            string rkFilter = TableQuery.GenerateFilterCondition("RowKey", QueryComparisons.GreaterThanOrEqual, "bterkaly");
            // Combine the partition key filter and the Row Key filter
            string combinedFilter = TableQuery.CombineFilters(rkFilter, TableOperators.And, pkFilter);
            // Construct a query
            TableQuery<EmailAddressEntity> query = new TableQuery<EmailAddressEntity>().Where(combinedFilter);
            // Execute the query
            EmailAddressEntity emailAddressEWntity = emailAddressTable.ExecuteQuery(query).First();


        }
    }
}