﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.WindowsAzure.Storage.Table;
using Microsoft.WindowsAzure.Storage.Table.DataServices;

namespace WebRole1
{

    // Our entity derives from TableEntity
    public class EmailAddressEntity : TableEntity
    {
        // Basic information that makes up our entity
        public string EMailAddress { get; set; }
        public string PhoneNumber { get; set; }

        // A necessary default constructor
        public EmailAddressEntity()
        {
        }

        // A two parameter constructor
        public EmailAddressEntity(string email, string phone)
        {
            EMailAddress = email;
            PhoneNumber = phone;
            SetKeys(email, phone);
        }

        // A method that initializes the partition key and row key
        public void SetKeys(string email, string phone)
        {
            int startIndex = email.IndexOf("@");
            // Extract the mailname from the email address
            string mailname = email.Substring(0, startIndex);
            // Extract the domain from the email address
            string domain = email.Substring(startIndex + 1);
            // Perform the mandatory assignments to the partition key and row key
            PartitionKey = domain;
            RowKey = mailname;
            PhoneNumber = phone;
        }
    }
}

